import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.python.core.Py;
import org.python.core.PyException;
import org.python.core.PyObject;
import org.python.core.PyType;
import org.python.util.PythonInterpreter;

public class JythonServlet extends HttpServlet {

    String jythonServletCode = "" +
        "from javax.servlet.http import HttpServlet\n" +
        "class jyServlet(HttpServlet):\n" + 
        "    def __init__(self):\n" + 
        "        HttpServlet.__init__(self)\n" + 
        "\n" + 
        "    def service(self, request, response):\n" + 
        "        response.getWriter().write('Hello World!')\n";

    protected PythonInterpreter interp;
    protected HttpServlet testJServlet;

    @Override
    public void init() throws ServletException {
        try {
            PythonInterpreter.initialize(System.getProperties(), System.getProperties(), new String[0]);
            interp = new PythonInterpreter();
            try {
                interp.exec(jythonServletCode);
            } catch (PyException ix) {
                throw new ServletException("Error executing jython servlet", ix);
            }
            PyObject pyServlet = ((PyType)interp.get("jyServlet")).__call__();
            Object temp = pyServlet.__tojava__(HttpServlet.class);
            if (temp == Py.NoConversion)
                throw new ServletException("Unable to convert jython servlet to java servlet");
            testJServlet = (HttpServlet)temp;
            testJServlet.init(this);
        } catch (PyException pyx) {
            throw new ServletException("Exception jython servlet: " + pyx.toString(), pyx);
        }
    }

    @Override
    public void service(HttpServletRequest req, HttpServletResponse resp) throws ServletException,
            IOException {
        testJServlet.service(req, resp);
    }

}
